////////////////////////////////////////////////////////////////////////////////
// CONFIDENTIAL and PROPRIETARY software of Magewell Electronics Co., Ltd.
// Copyright (c) 2011-2019 Magewell Electronics Co., Ltd. (Nanjing)
// All rights reserved.
// This copyright notice MUST be reproduced on all authorized copies.
////////////////////////////////////////////////////////////////////////////////

#import <Cocoa/Cocoa.h>
#import <AVFoundation/AVSampleBufferDisplayLayer.h>

#include "MWFOURCC.h"
#include "LibMWCapture/MWCapture.h"
#include "MWAudioRender.h"

@interface ViewController : NSViewController <NSWindowDelegate>

@property (nonatomic, assign) uint32_t width;
@property (nonatomic, assign) uint32_t height;
@property (nonatomic, assign) uint32_t frameDuration;
@property (nonatomic, assign) uint32_t fourcc;

@property (nonatomic, assign) uint32_t samplerate;
@property (nonatomic, assign) uint32_t audioChannels;
@property (nonatomic, assign) uint32_t bitsPerSample;

@property (nonatomic, assign) void  *audioRender;

@property (nonatomic, assign) bool running;
@property (nonatomic, assign) HCHANNEL hChannel;
@property (nonatomic, assign) pthread_t videoCaptureThreadId;
@property (nonatomic, assign) pthread_t audioCaptureThreadId;
- (void)onVideoCaptureProc;
- (void)onAudioCaptureProc;

@property (atomic, assign) float captureFps;
@property (nonatomic, assign) uint64_t lastTimestamp;
@property (nonatomic, assign) uint32_t videoFrameCount;

@property (nonatomic, assign) int32_t viewEnable;
@property (nonatomic, retain) AVSampleBufferDisplayLayer *videoLayer;
@property (nonatomic, assign) OSType pixelFormat;
@property (nonatomic, retain) NSMenu *deviceMenu;
@property (nonatomic, retain) NSMenuItem *selectedDeviceItem;
@property (weak) IBOutlet NSTextField *statusLabel;
@property (nonatomic, retain) NSTimer *statusTimer;

@end

